(* Program to calculate the traces of the decay of the muon, Eq. (5.64)

 Last Version: 22/11/2021
 Author: Jorge C. Romao
 email: jorge.romao@tecnico.ulisboa.pt
*)

(* Uncomment of not already loaded *)
(* Load FeynCalc 

<< FeynCalc`

*)

Remove["Global`*"]


(* Definition to simplify writing *)

prop[p_,m_]:=GS[p]+m
PL=(1 -GA[5])/2

(* Program *)
cst= g/Sqrt[2]/MW
Line1:= GS[q1] . GA[mu] . PL .  prop[k,mmu] . GA[nu] . PL 
Line2:= prop[p,me] . GA[mu] . PL . GS[q2] . GA[nu] . PL  
ans= Simplify[Contract[Tr[Line1] Tr[Line2]]]
ans=cst^4 ans/2;

Print["\!\(\*FractionBox[\(1\), \(2\)]\) \!\(\*UnderscriptBox[\(\[Sum]\), \(spins\)]\)|M\!\(\*SuperscriptBox[\(|\), \(2\)]\) = ",ans]
(*********************  End Program  **********************)
